/* SPDX-License-Identifier: GPL-2.0 */
#ifndef __ASM_PCI_H
#define __ASM_PCI_H

#include <linux/types.h>
#include <linux/slab.h>
#include <linux/dma-mapping.h>

#include <asm/io.h>

#define PCIBIOS_MIN_IO		0x1000

/*
 * Set to 1 if the kernel should re-assign all PCI bus numbers
 */
#define pcibios_assign_all_busses() \
	(pci_has_flag(PCI_REASSIGN_ALL_BUS))

#define HAVE_PCI_MMAP

/* Generic PCI */
#include <asm-generic/pci.h>

#include <linux/machine_t.h>
static inline bool arch_pci_mmap_wc_enabled(void)
{
	if (is_cpu_ft1500a() || is_cpu_ft2000ahk())
		return 0;
	else
		return 1;
}

#define arch_can_pci_mmap_wc()  arch_pci_mmap_wc_enabled()

#endif  /* __ASM_PCI_H */
