/* SPDX-License-Identifier: GPL-2.0-or-later */
/*
 * Copyright (C) 2024 KylinSoft Corporation.
 *
 * Authors: Huiwen He <hehuiwen@kylinos.cn>
 *
 * common header for kalert.
 *
 */
#ifndef _LINUX_KALERT_H
#define _LINUX_KALERT_H
#include <linux/types.h>
#include <uapi/linux/kalert.h>

#ifdef CONFIG_KYLIN_KALERT
int kalert_report_event(enum kalert_notify_type type, u32 event,
			enum kalert_notify_level level, const char *fmt, ...);
#else
static inline int kalert_report_event(enum kalert_notify_type type, u32 event,
				      enum kalert_notify_level level,
				      const char *fmt, ...)
{
	return 0;
}
#endif
#endif
