/* SPDX-License-Identifier: GPL-2.0 */
/*
 *  Kylin security modules
 *
 *  This file contains the Kylin security extend hooks.
 *  if LSM integrated hook can not meet your need, you
 *  should add your hooks in this file not "lsm_hook_defs.h"
 *
 *  Authors:  penghuaihe <penghuaihe@kylinos.cn>
 *
 *  Copyright (C) 2024, KylinSoft Corporation. All Rights Reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2,
 *  as published by the Free Software Foundation.
 */

LSM_HOOK(int, 0, module_delete, struct module *mod)
LSM_HOOK(int, -EINVAL, rewrite_cred, struct task_struct *tsk,
	 const char *name, void *value, size_t size)

LSM_HOOK(void, LSM_RET_VOID, inode_post_rename,
	 struct inode *old_dir, struct dentry *old_dentry,
	 struct inode *new_dir, struct dentry *new_dentry)
LSM_HOOK(void, LSM_RET_VOID, inode_copy_security,
	 struct inode *dest, struct inode *src)
LSM_HOOK(int, 0, inode_hide, u64 ino, struct inode *parent)
LSM_HOOK(int, -EPERM, cap_capable, const struct cred *cred,
	 struct user_namespace *targ_ns,
	 int cap, unsigned int opts)

LSM_HOOK(int, 0, net_device_permmission, struct net_device *ndev)
LSM_HOOK(int, 0, pci_dev_permission, struct pci_dev *pdev)
LSM_HOOK(int, 0, drm_connector_permission, struct drm_connector *connector)
LSM_HOOK(int, 0, device_permission, struct device *device, int dev_type)
LSM_HOOK(void, LSM_RET_VOID, path_mount_set_flags, const char *dev_name,
	 unsigned long *flags)
LSM_HOOK(int, 0, cdrom_permission, struct cdrom_device_info *cdi,
	 struct block_device *bdev, unsigned int cmd, unsigned long arg)
LSM_HOOK(void, LSM_RET_VOID, udev_disconnect, struct usb_device *udev)
LSM_HOOK(void, LSM_RET_VOID, kfile_close, struct file *filp)

/* These hooks are added for being compatible with V10 kysec1.0 */
LSM_HOOK(int, 0, dentry_mark_dirty, struct dentry *dentry, const char *op_type)
LSM_HOOK(void, LSM_RET_VOID, inode_notify, struct inode *dir, struct dentry *dentry)
LSM_HOOK(void, LSM_RET_VOID, kmemfd_create, struct inode *inode)
LSM_HOOK(int, 0, devctl_add_usbdevinfo, struct device *dev, struct usb_driver *driver,
	 struct usb_interface *intf)
LSM_HOOK(void, LSM_RET_VOID, devctl_notify_user, int plug, unsigned int pid,
	 unsigned int vid, int perm, char *serial, char *manufacture,
	 char *product)
LSM_HOOK(void, LSM_RET_VOID, cred_set_hash, struct linux_binprm *bprm)
LSM_HOOK(void, LSM_RET_VOID, device_add, struct device *dev)
LSM_HOOK(void, LSM_RET_VOID, device_del, struct device *dev)
LSM_HOOK(int, 0, skip_inode_setxattr, struct mnt_idmap *idmap,
	 struct dentry *dentry, const char *name, const void *value,
	 size_t size, int flags)
LSM_HOOK(int, 0, file_pre_open, struct file *file)
LSM_HOOK(int, 0, netfilter_drop, struct sk_buff *skb, struct nf_hook_state *state)
LSM_HOOK(void, LSM_RET_VOID, cdrom_disconnect, struct cdrom_device_info *cdi)
LSM_HOOK(void, LSM_RET_VOID, pre_override_creds, const struct cred *old, const struct cred *new)
LSM_HOOK(void, LSM_RET_VOID, pre_revert_creds, const struct cred *old, const struct cred *override)
