/* SPDX-License-Identifier: GPL-2.0 */
/*
 *  Kylin security modules
 *
 *  This file contains the Kylin security implementations.
 *
 *  Author:  penghuaihe <penghuaihe@kylinos.cn>
 *
 *  Copyright (C) 2024, KylinSoft Corporation. All Rights Reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2,
 *  as published by the Free Software Foundation.
 */

#ifndef _KSAF_INTF_H_
#define _KSAF_INTF_H_

#ifdef CONFIG_SECURITY_KSAF

extern rwlock_t ksaf_mnt_rwlock;

static inline void ksaf_mnt_read_lock(void)
{
	read_lock(&ksaf_mnt_rwlock);
}

static inline void ksaf_mnt_read_unlock(void)
{
	read_unlock(&ksaf_mnt_rwlock);
}

static inline void ksaf_mnt_write_lock(void)
{
	write_lock(&ksaf_mnt_rwlock);
}

static inline void  ksaf_mnt_write_unlock(void)
{
	write_unlock(&ksaf_mnt_rwlock);
}

#else /* CONFIG_SECURITY_KSAF */

static inline void ksaf_mnt_read_lock(void)
{}

static inline void ksaf_mnt_read_unlock(void)
{}

static inline void ksaf_mnt_write_lock(void)
{}

static inline void ksaf_mnt_write_unlock(void)
{}

#endif /* CONFIG_SECURITY_KSAF */

#endif
