/* SPDX-License-Identifier: GPL-2.0-or-later */

#include <sound/hda_codec.h>

//定义支持AW88XX项目子系统ID
#define SUBSYS_ID_T326	0x14F10066
#define SUBSYS_ID_LENOVO_X1	0x17aa350b
#define SUBSYS_ID_T350	0x14F10067
#define SUBSYS_ID_LENOVO_FT_X1	0x17aa3513

//判断是否为AW88XX项目的宏
#define IS_AW88XX_PROJECT(core) \
		((core)->subsystem_id == SUBSYS_ID_T326 || \
		 (core)->subsystem_id == SUBSYS_ID_LENOVO_X1 || \
		 (core)->subsystem_id == SUBSYS_ID_T350 || \
		 (core)->subsystem_id == SUBSYS_ID_LENOVO_FT_X1)

//判断是否为AW882XX项目的宏
#define IS_AW882XX_PROJECT(codec) \
		((codec)->core.subsystem_id == SUBSYS_ID_T326)

//判断是否为AW883XX项目的宏
#define IS_AW883XX_PROJECT(codec) \
		((codec)->core.subsystem_id == SUBSYS_ID_LENOVO_X1 || \
		 (codec)->core.subsystem_id == SUBSYS_ID_T350 || \
		 (codec)->core.subsystem_id == SUBSYS_ID_LENOVO_FT_X1)

int patch_aw882xx_auto(struct hda_codec *codec);
int patch_aw883xx_auto(struct hda_codec *codec);
