#!/bin/bash

if [ $USER = root ]; then
    dyndbg=/sys/kernel/debug/dynamic_debug/control
else
    dyndbg=/dev/stdout
fi

tx=" \
	-scm80211_flush \
	-scm80211_flush_hwq \
	-scm80211_deinit_txq \
	-scm80211_sched_txop_ampdu \
	-scm80211_sched_txop_sifs_burst \
	-scm80211_dump_txop \
	-scm80211_print_mdesc \
	-scm80211_print_txvector_raw \
	-scm80211_conf_tx \
	-scm80211_tx_channel \
	-scm80211_issue_txop \
	-scm80211_quick_prepare_txop \
	-scm80211_complete_txop \
	-scm80211_process_next_txq \
	-scm80211_submit_txq \
	-scm80211_txop_prepare_done \
	-scm80211_txop_free \
	-scm80211_discard_schedule \
	-scm80211_wake_tx_queue \
	-scm80211_complete_txq \
	-scm80211_setup_txvector \
	-scm80211_update_bsr_content \
	-scm80211_enable_mu_edca \
	-scm80211_disable_mu_edca
	-scm80211_mu_edca_timer
	-scm80211_need_reschedule_txop
	-scm80211_txh_prepare_sched
	-scm80211_txh_undo_schedule
	-scm80211_get_next_txq
	-__scm80211_txop_change_state
	-scm80211_hwq_work
	-scm80211_handle_tx_irq
	-scm80211_txop_get_rate
	-scm80211_tx
	+scm80211_schedule_txop
	+scm80211_start_backoff \
	+scm80211_abort_backoff \
	-scm80211_dequeue_pending_frames
	-scm80211_sta_rate_tbl_update
	+scm80211_complete_txop_prologue
	+scm80211_complete_txop_epilogue
	+scm80211_process_done_txop
	+scm80211_txop_update_transmit_window
	+scm80211_print_txvector
	"
rx=" \
	-scm80211_rx_poll \
	-scm80211_rx_irq \
	-scm80211_refill_rxring \
	-scm80211_update_rx_ring_ptrs \
	-scm80211_rx_work \
	-scm80211_rx \
	-scm80211_init_rx \
	-scm80211_rxh_dump_rxb \
	+scm80211_rxh_status
	-scm80211_rxring_work \
	-scm80211_refill_rxpool \
	-scm80211_sync_rx_wptr \
	-scm80211_rx_napi_irq \
	-scm80211_rx_mgnt
	-scm80211_bcn_mon_timer
	-scm80211_bcn_monitor_work
"
main=" \
	+ieee80211_register_hw \
	+scm80211_platform_remove \
	+scm80211_platform_probe \
	+scm80211_init_hw \
	+scm80211_croc \
	+scm80211_roc \
	+scm80211_roc_done \
	+scm80211_roc_start \
	+scm80211_sw_scan_complete \
	+scm80211_sw_scan_start \
	+scm80211_sta_remove \
	+scm80211_sta_add \
	+scm80211_bss_info_changed \
	+scm80211_leave_bss \
	+scm80211_assoc_bss \
	+scm80211_configure_filter \
	+scm80211_config_iface_filter \
	+scm80211_remove_interface \
	+scm80211_change_interface \
	+scm80211_add_interface \
	+scm80211_config \
	+scm80211_stop \
	+scm80211_start \
	+scm80211_set_channel \
	+scm80211_set_basic_ht_mcs_set \
	+scm80211_set_erp \
	+scm80211_set_basic_rates \
	+scm80211_set_bssid \
	+scm80211_set_vht_partial_aid \
	+scm80211_clr_vht_partial_aid \
	+scm80211_set_he_uora_cfg_ch_info \
	+scm80211_set_he_uora_cfg \
	+scm80211_set_he_info \
	+scm80211_clr_he_info \
	-scm80211_handle_irq \
"

sec=" \
	+scm80211_set_key \
	+scm80211_install_key \
	+scm80211_remove_key \
	-scm80211_pcie_remap \
	-scm80211_pcie_unmap \
	-phy_writel \
	-max2829_spi_reg_write \
	+scm80211_pcie_start_wise \
	-phy_writel \
	-scm80211_get_twt_state \
"

func="$main $tx $rx $sec"

for f in $func; do
    echo "func ${f##[+|-]} ${f%%${f##[+|-]}}p" > ${dyndbg}
done
