#!/bin/sh

VERSION="SCM2625_A1_$1"
DATE=`date +%Y%m%d_%H%M_%S%3N`
#_S means source code dir, _B means binary DIR.
RELDIR_S=$VERSION"_"$DATE"_src"
RELDIR_B=$VERSION"_"$DATE
DIR="$( cd "$( dirname "$0" )" && pwd )"

echo "Version $RELDIR_B"
#remove old package if exist.
echo "Removing SCM2625_A1_*"
rm -fr SCM2625_A1_*

#Pack and build source code.
echo "Creating direcory $RELDIR_B"
mkdir -p $RELDIR_S/mac80211/scripts
mkdir -p $RELDIR_B/mac80211/scripts

echo "Building the code"
cd ../
make clean
rsync -a ./* $DIR/$RELDIR_S/mac80211/
cp -r ./.git* $DIR/$RELDIR_S/mac80211/
#SILICON=scm2020_a0 make modules VERSION_STRING=$1
#make modules
SILICON=scm2020_a1 make modules

#Pack binary
if [ -f scm80211-usb.ko ]; then
	echo "Packing the binary"
	chmod a+x scm80211-usb.ko
	chmod a+x scm80211-pcie.ko
	chmod a+x scm-btusb.ko
	cp -f scm80211-usb.ko $DIR/$RELDIR_B/mac80211/
	cp -f scm80211-pcie.ko $DIR/$RELDIR_B/mac80211/
	cp -f scm-btusb.ko $DIR/$RELDIR_B/mac80211/

	cp -fr firmware $DIR/$RELDIR_B/mac80211/
	cp -f scripts/*.sh $DIR/$RELDIR_B/mac80211/scripts/
	cp -f scripts/run $DIR/$RELDIR_B/mac80211/scripts/

	if [ -f $DIR/build.log ]; then
		rsync $DIR/build.log $DIR/$RELDIR_S/mac80211/scripts/
	fi

	if [ -f auto_version.h ]; then
		cp -f auto_version.h $DIR/$RELDIR_S/mac80211/
	fi

	if [ -d $DIR/$RELDIR_S/mac80211/scripts/$RELDIR_B ]; then
		rm -fr $DIR/$RELDIR_S/mac80211/scripts/$RELDIR_B
	fi

	if [ -d $DIR/$RELDIR_S/mac80211/scripts/$RELDIR_S ]; then
		rm -fr $DIR/$RELDIR_S/mac80211/scripts/$RELDIR_S
	fi
else
	echo "Build Error, no scm80211-usb.ko is generated!!!"
fi
