#!/bin/bash
# SPDX-License-Identifier: BSD-2-Clause
#
# Copyright (c) 2024-2026 Senscomm Semiconductor Co., Ltd.
#

DIR="$( cd "$( dirname "$0" )" && pwd )"
DRIVERDIR="$(dirname "${DIR}")"
RELEASEDIR="$(dirname "${DRIVERDIR}")"

VERSION_STRING=`git describe --tags`
DATE_STRING=`date "+20%y.%m.%d %k:%M"`
DATE=`date +%Y%m%d-%H%M`

VERSION_FILE_NAME=${DRIVERDIR}/auto_version.h
DRV_NAME=${RELEASEDIR}/${VERSION_STRING}_${DATE}.tar.gz

touch ${VERSION_FILE_NAME}
echo "/* SPDX-License-Identifier: GPL-2.0 OR BSD-2-Clause */" > ${VERSION_FILE_NAME}
echo "#define RELEASE_DATE \"$DATE_STRING\""	>> ${VERSION_FILE_NAME}
echo "#define DRIVER_VERSION \"$VERSION_STRING\"" >> ${VERSION_FILE_NAME}

tar -czvf $DRV_NAME --exclude=.git* -C $RELEASEDIR mac80211 > /dev/null

echo "Release  $DRV_NAME  success!"
