##########################################################################
# File Name: sanity.sh
# Author: allen-wang
# mail: allen.wang@senscomm.com
# Created Time: 2020年12月4日 星期三 14时24分35秒
#########################################################################
#!/bin/bash

INTF="wlp1s0"
NULL_PWD="NONE"
AP_CONFIG=(
""HUAWEI-open"			"NONE"		"192.168.3.1""
""HUAWEI-open_5G"		"NONE"		"192.168.3.1""
""honor_test_wpa2"		"12345678"	"192.168.3.1""
""honor_test_5g_wpa2"		"12345678"	"192.168.3.1""
""Xiaomi_8296_wpa3"		"12345678"	"192.168.31.1""
""Xiaomi_8296_5g_wpa3"		"12345678"	"192.168.31.1""
)

echo "Try to connect test"
len=${#AP_CONFIG[@]}
for((i=0;i<${len};i++));
do
	AP1=(${AP_CONFIG[$i]})
	AP_SSID=(${AP1[0]})
	AP_PWD=(${AP1[1]})
	AP_IP=(${AP1[2]})
	echo "SSID: $AP_SSID PWD:$AP_PWD IP: $AP_IP"
	echo "Start to Connect to AP: $AP_SSID" > /dev/kmsg

	if [[ $AP_PWD == $NULL_PWD ]]
	then
		AP_PWD=""
	else

		AP_PWD="password $AP_PWD"
	fi

	iw dev $INTF scan > /dev/null
	if nmcli device wifi connect $AP_SSID $AP_PWD
	then
		echo "Connection $AP_SSID is success"
	else
		echo "Failed to Connect to $AP_SSID"
		exit 0
	fi

	sleep 5

	if ping -c 10 $AP_IP >/dev/null
	then
		echo "$AP_SSID Ping is success"
	else
		echo "$AP_SSID Ping is failed"
		exit 0
	fi
done

echo "Try to Test P2P Function"
REMOTE_P2P_HOST_IP="192.168.3.8"
REMOTE_P2P_PORT="9878"
REMOTE_INF="wlp2s0"
WPS_PING="12345678"
REMOTE_P2P_DEV_IP="192.168.43.1"
REMOTE_P2P_DEV_ADDR="9c:fc:e8:0c:bd:6d "

LOCAL_INF="wlp1s0"
LOCAL_P2P_DEV_IP="192.168.43.100"
LOCAL_CTRL_INTF=/var/run/wpa_ctrl
LOCAL_CLI=/usr/bin/wpa_cli
REMOTE_CLI=/usr/bin/wpa_cli_rc

echo "Start Remote wpa-supplicant"
ssh test@$REMOTE_P2P_HOST_IP "cd ~/source/sanity;nohup sh ./start_wpa.sh > /dev/null 2>&1 &"
sleep 3

echo "Start Remote P2P GO"
sudo $REMOTE_CLI -i $REMOTE_P2P_HOST_IP:$REMOTE_P2P_PORT SET p2p_no_group_iface 1
sleep 1
sudo $REMOTE_CLI -i $REMOTE_P2P_HOST_IP:$REMOTE_P2P_PORT p2p_group_add freq=2412
sleep 1
sudo $REMOTE_CLI -i $REMOTE_P2P_HOST_IP:$REMOTE_P2P_PORT IFNAME=$REMOTE_INF wps_pin any $WPS_PING
ssh test@$REMOTE_P2P_HOST_IP "sudo ifconfig $REMOTE_INF $REMOTE_P2P_DEV_IP"

echo "Try to setup P2P connection"
echo "Try to start local wpa_supplicant"
sudo killall wpa_supplicant
sudo wpa_supplicant -Dnl80211 -i $LOCAL_INF -c p2p0.conf -ddd -g $LOCAL_CTRL_INTF &

sudo $LOCAL_CLI -g $LOCAL_CTRL_INTF SET p2p_no_group_iface 1
sudo $LOCAL_CLI -g $LOCAL_CTRL_INTF p2p_find
sleep 3
sudo $LOCAL_CLI -g $LOCAL_CTRL_INTF p2p_connect $REMOTE_P2P_DEV_ADDR WPS_PIN join
sleep 5
sudo ifconfig $LOCAL_INF $LOCAL_P2P_DEV_IP
if ping -c 10 $REMOTE_P2P_HOST_IP >/dev/null
then
	echo "Ping P2P peer success"
else
	echo "Ping P2P peer failed"
	exit 0
fi

