#!/bin/bash


ksaf_common_kunit_test() {
        # 触发策略
        echo "xxxxxx" > $WORK_DIR_COMMON/disallow/test.txt
        if [ "x$?" = "x0" ];then
                print_fail 文件只读管控测试项测试失败！
        else
                print_success 文件只读管控测试项测试通过！
        fi

        echo "ls -l " > $WORK_DIR_COMMON/allow/test.txt
        cat $WORK_DIR_COMMON/allow/test.txt
        if [ "x$?" = "x0" ];then
                print_success 访问特许文件测试项测试通过！
        else
                print_fail 访问特许文件测试项测试失败！
        fi

        cat $WORK_DIR_COMMON/func.txt
        make --help

        # 下面的测试用例，都是为了尽量做更多的操作，使模块的所有代码都执行到
        ls -l $WORK_DIR_COMMON/rename.txt
        mv $WORK_DIR_COMMON/rename.txt  $WORK_DIR_COMMON/rename.txt2
        mv $WORK_DIR_COMMON/rename.txt2 $WORK_DIR_COMMON/rename.txt

        # 测试bash脚本 interpret
        cp `which bash` $WORK_DIR_COMMON
        setfattr -n security.ksaf -v "0-0-0:1:0-0-0:0:0-0-0" $WORK_DIR_COMMON/bash
        getfattr -dm- $WORK_DIR_COMMON/bash
        $WORK_DIR_COMMON/bash $WORK_DIR_COMMON/allow/test.txt

        #
        # 测试common/debug.c
        #
        cat /sys/kernel/security/ksaf/common/debug/flag
        echo "1234" > /sys/kernel/security/ksaf/common/debug/pid
        echo "1234" > /sys/kernel/security/ksaf/common/debug/inode
        cat /sys/kernel/security/ksaf/common/debug/inode
        cat /sys/kernel/security/ksaf/common/debug/pid
        echo "0" > /sys/kernel/security/ksaf/common/debug/pid
        echo "0" > /sys/kernel/security/ksaf/common/debug/inode
        cat /sys/kernel/security/ksaf/common/debug/inode
        cat /sys/kernel/security/ksaf/common/debug/pid
        echo "0" > /sys/kernel/security/ksaf/common/debug/flag

        #
        # 测试common/fs.c
        #
        cat /sys/kernel/security/ksaf/common/policy_info
        cat /sys/kernel/security/ksaf/common/id_pairs
        ksaf_status=`cat /sys/kernel/security/ksaf/status`
        echo $ksaf_status > /sys/kernel/security/ksaf/status

        #
        # 测试common/hooks.c
        #
        # 测试继承标识
        mkdir -p $WORK_DIR_COMMON/testdir1
        setfattr -n security.ksaf -v "0-0-0:0:0-0-0:1:0-0-0" $WORK_DIR_COMMON/testdir1
        mkdir -p $WORK_DIR_COMMON/testdir2
        setfattr -n security.ksaf -v "0-0-0:0:0-0-0:2:0-0-0" $WORK_DIR_COMMON/testdir2
        mkdir -p $WORK_DIR_COMMON/testdir3
        setfattr -n security.ksaf -v "0-0-0:0:0-0-0:3:0-0-0" $WORK_DIR_COMMON/testdir3
        mkdir -p $WORK_DIR_COMMON/testdir4
        setfattr -n security.ksaf -v "0-0-0:0:0-0-0:4:0-0-0" $WORK_DIR_COMMON/testdir4
        mkdir -p $WORK_DIR_COMMON/testdir5
        setfattr -n security.ksaf -v "0-0-0:0:0-0-0:5:0-0-0" $WORK_DIR_COMMON/testdir5
        mkdir -p $WORK_DIR_COMMON/testdir6
        setfattr -n security.ksaf -v "0-0-0:0:0-0-0:6:0-0-0" $WORK_DIR_COMMON/testdir6
        touch $WORK_DIR_COMMON/testdir1/testfile
        touch $WORK_DIR_COMMON/testdir2/testfile
        touch $WORK_DIR_COMMON/testdir3/testfile
        touch $WORK_DIR_COMMON/testdir4/testfile
        touch $WORK_DIR_COMMON/testdir5/testfile
        touch $WORK_DIR_COMMON/testdir6/testfile
        touch $WORK_DIR_COMMON/testdir6/testfile2
        mv $WORK_DIR_COMMON/testdir6/testfile2 $WORK_DIR_COMMON/testdir5/
        # 读写进程身份
        cat /proc/self/attr/ksaf/current
        echo "0-0-0:0:0-0-0:0:0" > /proc/self/attr/ksaf/current

        #
        # 测试common/label.c
        #
}

ksaf_modctl_kunit_test() {
        if lsmod | grep -q "^ksaf_kunit_test_mod "; then
                print_info "ksaf test modules has been loaded!"
        else
                insmod $SRC/kunit/ksaf_kunit_test_mod.ko
        fi

        rmmod ksaf_kunit_test_mod
        if [ "x$?" = "x0" ];then
                print_fail 内核模块保护测试项测试失败！
        else
                print_success 内核模块保护测试项测试通过！
        fi
}

ksaf_netctl_kunit_test() {
        /usr/bin/ping          -c 1 127.0.0.1
        if [ "x$?" = "x0" ];then
                print_success 联网管控特殊放行测试项测试通过！
        else
                print_fail 联网管控特殊放行测试项测试失败！
        fi
        $WORK_DIR_COMMON/ping  -c 1 127.0.0.1
        $WORK_DIR_COMMON/ping2 -c 1 127.0.0.1
        if [ "x$?" = "x0" ];then
                print_fail 联网管控黑名单测试项测试失败！
        else
                print_success 联网管控黑名单测试项测试通过！
        fi

        # 第一次执行，继承的是当前脚本的身份，此次放在后台执行，会使用自己的身份
        setsid /usr/bin/ping          -c 1 127.0.0.1 &
        setsid $WORK_DIR_COMMON/ping  -c 1 127.0.0.1 &
        setsid $WORK_DIR_COMMON/ping2 -c 1 127.0.0.1 &
}

ksaf_kunit_test() {

        # /ksaf_main_kunit/common
        export  WORK_DIR_COMMON="$WORK_DIR"/common
        rm -rf $WORK_DIR_COMMON

        mkdir -p $WORK_DIR_COMMON/allow
        touch    $WORK_DIR_COMMON/allow/test.txt
        mkdir -p $WORK_DIR_COMMON/disallow
        touch    $WORK_DIR_COMMON/disallow/test.txt

        touch    $WORK_DIR_COMMON/rename.txt

        cp /usr/bin/echo $WORK_DIR_COMMON
        touch $WORK_DIR_COMMON/func.txt

        cp -a /usr/bin/ping $WORK_DIR_COMMON
        cp -a /usr/bin/ping $WORK_DIR_COMMON/ping2

        mkdir -p $WORK_DIR_COMMON/recur/recur1
        mkdir -p $WORK_DIR_COMMON/recur/recur2
        mkdir -p $WORK_DIR_COMMON/recur/recur2/recur.txt

        # 配置测试用策略
        cat <<EOF > /etc/ksaf/policy/ksaf_kunit.p
string name="ksaf_main"

int mynum=2
int priority=100

disallow * * "$WORK_DIR_COMMON/disallow/test.txt" file {write}
disallow * * "$WORK_DIR_COMMON/echo"              file {exec}

# 测试allow 优先
disallow * * "$WORK_DIR_COMMON/allow/test.txt"    file {read}
detect   * * "$WORK_DIR_COMMON/allow/test.txt"    file {read}
allow    * * "$WORK_DIR_COMMON/allow/*"           file {read}

# 下发针对包、路径、通配策略
allow    * * "make"                               file {exec}
allow    * * "/usr/bin/make"                      file {exec}
allow    * * *                                    file {rename}

# 递归策略，主客体
allow * * "$WORK_DIR_COMMON/recur/recur/*"  file {read}
allow * * "$WORK_DIR_COMMON/recur/recur1/*" file {write}
allow * * "$WORK_DIR_COMMON/recur/recur2/*" file {rename}
allow * "$WORK_DIR_COMMON/recur/recur/*" *  file {read}
allow * "$WORK_DIR_COMMON/recur/recur1/*" * file {write}
allow * "$WORK_DIR_COMMON/recur/recur2/*" * file {rename}

# 这些策略主要是为了查看策略的时候，各种类型策略都有，能尽量覆盖相关的所有代码
allow * * "/file_not_exist" dir {rename}
allow * * "/file_not_exist" lnkfile {rename}
allow * * "/file_not_exist" file {read, open, write, truncate, exec}
allow * * "/file_not_exist" file {mkdir, rmdir, link, unlink, symlink}
allow * * "/file_not_exist" file {rename, setattr, getattr, setxattr, getxattr}
allow * * "/file_not_exist" file {kmodinsert, show, interpret}
allow * * * usb {use, write}
allow * * "$WORK_DIR_COMMON/echo" process {kill}
allow * * kvm kmod {remove}
allow * "/usr/bin/wget" * socket {connect}
allow root * * cap {use}

# 测试附加函数
disallow * * "$WORK_DIR_COMMON/func.txt" file {read} if (ksaf_kunit_test_true(1, "test"))
disallow * * "$WORK_DIR_COMMON/func.txt" file {read} if (ksaf_kunit_test_true & ksaf_kunit_test_false)
disallow * * "$WORK_DIR_COMMON/func.txt" file {read} if (ksaf_kunit_test_false | ksaf_kunit_test_true)
disallow * * "$WORK_DIR_COMMON/func.txt" file {read} if (!ksaf_kunit_test_true)
disallow * * "$WORK_DIR_COMMON/func.txt" file {read} if (ksaf_kunit_test_NUM3 < \$mynum)
disallow * * "$WORK_DIR_COMMON/func.txt" file {read} if (ksaf_kunit_test_NUM3 > \$mynum)
disallow * * "$WORK_DIR_COMMON/func.txt" file {read} if (ksaf_kunit_test_NUM3 = \$mynum)
disallow * * "$WORK_DIR_COMMON/func.txt" file {read} if (ksaf_kunit_test_NUM3 >= \$mynum)
disallow * * "$WORK_DIR_COMMON/func.txt" file {read} if (ksaf_kunit_test_NUM3 <= \$mynum)
disallow * * "$WORK_DIR_COMMON/func.txt" file {read} if (ksaf_kunit_test_NUM3 != \$mynum)

# 测试respond
respond * *  "$WORK_DIR_COMMON/func.txt" file {read} do {ksaf_kunit_test_true, ksaf_kunit_test_false}

# 内核模块保护策略
disallow * * "ksaf_kunit_test_mod" kmod {remove}
detect   * * "ksaf_kunit_test_mod" kmod {remove}

# 联网管控策略
disallow * "$WORK_DIR_COMMON/ping" * socket {connect}
disallow * "$WORK_DIR_COMMON/*" *    socket {connect}
detect * "$WORK_DIR_COMMON/ping2" *  socket {connect}

EOF

        # 低优先级策略
        cat <<EOF > /etc/ksaf/policy/ksaf_kunit_low.p

string name="ksaf_main_low"
int priority=90

# 联网管控策略
disallow * "/usr/bin/ping" *         socket {connect}
allow * * *                          socket {connect}

EOF



        ksaf-main-policy-sync
        if [ "x$?" = "x0" ];then
                print_success 策略下发测试项测试通过！
        else
                print_fail 策略下发测试项测试失败！
                exit 1
        fi

        sync
        sleep 3

        # ksaf_test_user.c里面实现的是一般操作无法触发的测试项
        gcc -O0 -o $SRC/kunit/ksaf_test_user $SRC/kunit/ksaf_test_user.c
        chmod a+x $SRC/kunit/ksaf_test_user
        $SRC/kunit/ksaf_test_user

        ksaf_common_kunit_test
        ksaf_modctl_kunit_test
        ksaf_netctl_kunit_test

        # 测试结束后，恢复原本的策略
        rm -rf /etc/ksaf/policy/ksaf_kunit.p
        rm -rf /etc/ksaf/policy/ksaf_kunit_low.p
        ksaf-main-policy-sync

}
