# SPDX-License-Identifier: GPL-2.0

trap   ""  INT QUIT  TSTP
fix_package()
{
	if [ $1 = 'deb' ]; then
		tmp=`dpkg -L $2`
	elif [ $1 = 'rpm' ]; then
		tmp=`rpm -ql $2`
	fi
	for i in $tmp
	do
		if [ ! -f $i ] && [ ! -d $i ]; then
		#touch null file for backup
			touch $i
		fi
	done
}

backup_kernel_rpm()
{

	for PACKAGE in $BACKUP_LIST; do
		echo $PACKAGE
		##不备份kernel-4.19.90、kernel-kdump-4.19.90
		tmp=`echo "$PACKAGE" | grep "kernel-4.19.90"`
		tmp="$tmp`echo "$PACKAGE" | grep "kernel-kdump-4.19.90"`"
		if [ -z "$tmp" ] ;then
			fix_package $1 $PACKAGE
			rpm -ql "$PACKAGE" | grep -v "$OLD_KERNEL_VERSION" |grep -v "modules" | xargs -I {} cp --parents --preserve -r "{}" "$BACK_PATH"
		fi
	done

}

backup_kernel_boot()
{
	#备份旧内核boot文件
	BOOT_FILE=`ls /boot/ |grep 4.19.90 |grep -v "$update_kernel_name"`
	for i in $BOOT_FILE
	do
		echo $i
		tmp="/boot/$i"
		echo $tmp | xargs -I {} cp --parents --preserve -r "{}" "$BACK_PATH"
		if [ $? -eq 0 ]; then
			rm $tmp -rf
		fi
	done
}

rm_backup_file()
{
	sed -i '$d' $BACK_DIR"kernel_info.txt"
	rm $BACK_PATH /opt/kernel_old_pkg.txt  -rf 2>&1 >> /dev/null
	rm /opt/kernel_info.txt /opt/kernel_old_driver.txt   -rf 2>&1 >> /dev/null
	tmp=`cat $BACK_DIR"kernel_info.txt"`
	if [ -z "$tmp" ];then
		rm $BACK_DIR -rf 2>&1 >> /dev/null
	fi

}

backup_kernel()
{
	echo backup_kernel......
	if [ "$1" = 'deb' ]; then
		PKG_REPACK="dpkg-repack"
		mkdir $BACK_PATH
		cd $BACK_PATH
	#get kernel vmlinuz
	#fix pkg can't backup
		for i in $BACKUP_LIST
		do
			fix_package $1 $i &
		done
		wait
		BACKUP_PKG_NUMS=0
		for i in $BACKUP_LIST
		do
			$PKG_REPACK  $i >/dev/null 2>&1 &
			#多线程优化
			BACKUP_PKG_NUMS=$((BACKUP_PKG_NUMS+1))
		done
		wait

		backup_pkg=`ls /opt/old_kernel_pkg/*.deb | wc -l`

		if [ $BACKUP_PKG_NUMS = $backup_pkg ]; then
			echo "backup kernel succeed"
		else
			echo "backup kernel failed"
			rm_backup_file
			exit 0
		fi
		cd -
	elif [ "$1" = 'rpm' ]; then
		# 备份grub
		mkdir $BACK_PATH
		backup_kernel_rpm $1
		echo "backup kernel succeed"
	fi
}

check_deb_or_rpm()
{
	BACK_DIR=/opt/backup_kernel/
	OLD_GRUB=`find /boot -name "grub.cfg" | head -n 1`
	NEW_GRUB=`find /boot -name "grub.cfg"`
        tmp=`ls kernel_pkg | grep "\.rpm"`
        if [ -z "$tmp" ]; then
                PKG_DEB_OR_RPM="deb"
        else
                PKG_DEB_OR_RPM="rpm"
        fi
}

get_kernel_info()
{
	GRUB_FLAG=0
	if [ -f $BACK_DIR"kernel_info.txt"  ]; then
		OLD_KERNEL_VERSION=`tail -n 1 $BACK_DIR"kernel_info.txt" | awk -F " " '{print$1}'`
		update_kernel_name=`tail -n 1 $BACK_DIR"kernel_info.txt" | awk -F " " '{print$2}'`
	else
		return 0
	fi
}

update_grub()
{

  if [ $(uname -m)  =  "loongarch64"   ];then
		  kdump=`find /boot/ -maxdepth 1 |grep kdump`
      if [[ $kdump != "" ]]; then
        mkdir /opt/kdump/
        mv /boot/*kdump* /opt/kdump
      fi
		fi

	for i in $NEW_GRUB
	do
		grub2-mkconfig --output=$i 2>/dev/null
	done

	if [ $(uname -m)  =  "loongarch64"   ];then
      if [  -d "/opt/kdump/" ];then
        mv /opt/kdump/* /boot/
        rm -rf /opt/kdump/
      fi
		fi
}

rollback_kernel()
{
	if [ $1 = "deb" ]; then
		#
		sed -i $ROLL_CMDLINE_LINUX /etc/default/grub
		${rm_new_kernel} 2>/dev/null
		${ROLLBACK_KERNEL} 2>/dev/null
	elif [ $1 = "rpm" ]; then
		${rm_new_kernel}  2>&1 >/dev/null

		\cp -a  $BACK_PATH/* /

		update_grub

		if [ ! -z $update_kernel_name ];then
			tmp=`ls /boot |grep $update_kernel_name`
			for i in $tmp
			do
				rm /boot/$i  -rf 2>&1 >> /dev/null
			done
		fi
	fi
	rm_backup_file
	echo "rollback kernel succeed"
	return 1
}

check_new_and_old_kernel_version()
{
	check_deb_or_rpm

	if [ $PKG_DEB_OR_RPM = "deb" ]; then
		update_kernel_name=`ls kernel_pkg/*-image-*  |awk -F "-" '{print$3"-"$4}'`
		tmp=`dpkg -l |grep "$update_kernel_name"`
		tmp1=`cat $OLD_GRUB |grep menuentry |grep "$update_kernel_name"`
	else
		update_kernel_name=`ls kernel_pkg/kernel-core-* | awk -F "-" '{print$3"-"$4}' | awk -F ".rpm" '{print$1}'`
		tmp=`rpm -qa |grep "$update_kernel_name"`
		tmp1=`cat $OLD_GRUB |grep menuentry |grep "$update_kernel_name"`
	fi
	if [ ! -z "$tmp" ] && [ ! -z "$tmp1" ] ;then
		echo "Consistent kernel version"
	else
		echo "Inconsistent kernel versions"
	fi

}

update_kernel()
{
	if [ $1 = "deb" ]; then
		sed -i $NEW_CMDLINE_LINUX /etc/default/grub
	fi
	if [ $1 = "deb" ]; then
		${rm_old_kernel}
		cd kernel_pkg
		${UPDATE_KERNEL}
		cd -
		cd driver_pkg
		${UPDATE_DRIVER} 2>/dev/null
		echo "Update kernel succed"
		cd -
	else
	        if [ $GRUB_FLAG = "0" ];then
        	        UPDATE_KERNEL="rpm -ivh kernel_pkg/*.rpm --force --nodeps"
	        elif [ $GRUB_FLAG = "1" ];then
			update_grub

        	        UPDATE_KERNEL=""

	        fi
		${UPDATE_KERNEL} 2>/dev/null
		tmp=`rpm -qa |grep $update_kernel_name`
		if [ -z "$tmp" ];then
			echo "Update kernel failed"
			\cp -a  $BACK_PATH/* /
			rm_backup_file
			return 1
		fi
		backup_kernel_boot
		update_grub
	fi
}

#收集旧内核名称和
collect_kernel_info()
{
	GRUB_FLAG=0
	OLD_KERNEL_VERSION=`uname -r`
	if [ $PKG_DEB_OR_RPM = "deb" ];then
		update_kernel_name=`ls kernel_pkg/*-image-*  |awk -F "-" '{print$3"-"$4}'`
		tmp=`dpkg -l |grep "$update_kernel_name"`
		tmp1=`cat $OLD_GRUB |grep "$update_kernel_name"`
	else
		update_kernel_name=`ls kernel_pkg/kernel-core-* | awk -F "-" '{print$3"-"$4}' | awk -F ".rpm" '{print$1}'`
		tmp=`rpm -qa |grep "$update_kernel_name"`
		tmp1=`cat $OLD_GRUB |grep menuentry | grep "$update_kernel_name"`
	fi
	#内核已经安装，grub已经更新
	if [ ! -z "$tmp" ] && [ ! -z "$tmp1" ];then
		echo "kypatch: No upgrade required for kernel"
		exit 0
	#内核已经安装，但grub没有更新
	elif [ ! -z "$tmp" ] && [ -z "$tmp1" ];then
		GRUB_FLAG=1
	fi
	#内核未安装
	if [ $PKG_DEB_OR_RPM = "rpm" ];then
		if [ -f /opt/kernel_info.txt ];then
			OLD_KERNEL_VERSION=`sed -n '3p' /opt/kernel_info.txt`
			echo $OLD_KERNEL_VERSION
		fi
		#多补丁安装时，前一个补丁的NEW kernel为当前补丁的OLD kernel
		if [ -f $BACK_DIR"kernel_info.txt" ];then
			tmp=`tail -n 1 $BACK_DIR"kernel_info.txt" | awk -F " " '{print$2}'`
			if [ ! -z "$tmp" ];then
				echo $OLD_KERNEL_VERSION
				OLD_KERNEL_VERSION=$tmp
			fi
		fi
	fi
	echo $BACK_DIR
	if [ ! -d $BACK_DIR ];then
		mkdir $BACK_DIR
	fi
	echo "$OLD_KERNEL_VERSION $update_kernel_name" >>$BACK_DIR"kernel_info.txt"
}

init_rcom()
{
	# for backup old kernel
	BACK_DIR=/opt/backup_kernel/
	BACK_PATH=$BACK_DIR$OLD_KERNEL_VERSION
	if [ ! -f $BACK_DIR"kernel_old_pkg.txt" ];then
		rpm -qa |grep 4.19.90 | grep $OLD_KERNEL_VERSION  >$BACK_DIR"kernel_old_pkg.txt"
		BACKUP_LIST=`cat $BACK_DIR"kernel_old_pkg.txt"`
	fi
	rm_new_kernel="rpm -e"
	for i in $(ls kernel_pkg/)
	do
		tmp=`echo $i | awk -F ".rpm" '{print$1}'`
		rm_new_kernel="$rm_new_kernel $tmp"
	done
	echo $rm_new_kernel
        #for update new kernel
        nv_gpu=`rpm -qa |grep nvidia`
        rm_nv="rpm e $nv_gpu"
        #for rollback rm new kernel

        #for add grub
	#for check whether update
	#无需更新
}

init_ucom()
{
	# for backup old kernel

	if [ ! -f /opt/kernel_old_pkg.txt ]; then
		dpkg -l | grep 4.4.131 | awk -F " " '{print $2}' >/opt/kernel_old_pkg.txt
		BACKUP_LIST=`cat /opt/kernel_old_pkg.txt`
		echo $BACKUP_LIST
	#get backup driver
		tmp=`dpkg -l |grep "linux-libc-dev" | awk -F " " '{print$2}'`
		if [ ! -z "$tmp" ]; then
			BACKUP_LIST="$BACKUP_LIST $tmp"
			echo $tmp >>/opt/kernel_old_pkg.txt
		fi
	fi

	if [ ! -f /opt/kernel_old_driver.txt ]; then
		for i in $(ls driver_pkg)
		do
			tmp=`echo $i | awk -F "_" '{print$1}'`
			ret=`dpkg -l | grep $tmp | awk -F " " '{print$2}'`
			BACKUP_LIST="$BACKUP_LIST $ret"
			echo $ret >>/opt/kernel_old_driver.txt
		done
	fi

	BACK_PATH=/opt/old_kernel_pkg
	#for update new kernel
	UPDATE_KERNEL="dpkg -i"
	UPDATE_DRIVER="dpkg -i"
	ROLLBACK_KERNEL="dpkg -i /opt/old_kernel_pkg/*.deb"
	#增量更新
	rm_new_kernel="dpkg -P"
        rm_old_kernel="dpkg -P"
	#旧内核
        update_kernel_name=`ls kernel_pkg/*-image-*  |awk -F "-" '{print$3"-"$4}'`
        old_kernel_name=`cat /opt/kernel_old_pkg.txt | grep 4.4.131 | head -n 1 | awk -F "-" '{print$3"-"$4}'`
	NEW_REPLACE_OLD_NAME="s/$old_kernel_name/$update_kernel_name/g"
        for i in $(cat /opt/kernel_old_pkg.txt)
        do
		tmp=`echo $i |sed $NEW_REPLACE_OLD_NAME`
		echo "$tmp $i"
		ret=`ls kernel_pkg |grep "$tmp\_"`

		if [ ! -z "$ret" ];then
			UPDATE_KERNEL="$UPDATE_KERNEL $ret"
			if [ "$i" != "linux-libc-dev:arm64" ]; then
				rm_new_kernel="$rm_new_kernel $tmp"
				rm_old_kernel="$rm_old_kernel $i"
			fi
		elif [ "$i" = "linux-libc-dev:arm64" ];then
			ret=`ls kernel_pkg |grep "linux-libc-dev"`
			UPDATE_KERNEL="$UPDATE_KERNEL $ret"
		fi

        done
	#rm new driver pkg
	echo "$rm_new_kernel $rm_old_kernel"
	if [ ! -f  '/opt/kernel_old_driver.txt' ]; then
		UPDATE_DRIVER=""
	else
		for i in $(cat /opt/kernel_old_driver.txt)
		do
			tmp=`ls driver_pkg |grep $i `
			UPDATE_DRIVER="$UPDATE_DRIVER $tmp"
			rm_new_kernel="$rm_new_kernel $i"
		done
	fi
	#for rollback rm new kernel

	#for add grub
	ROLL_CMDLINE_LINUX="s/GRUB_CMDLINE_LINUX=\"mem_sleep_default=nosuspend\"/GRUB_CMDLINE_LINUX=\"\"/g"
	NEW_CMDLINE_LINUX="s/GRUB_CMDLINE_LINUX=\"\"/GRUB_CMDLINE_LINUX=\"mem_sleep_default=nosuspend\"/g"

}

init_com()
{

	if [ $1 = "deb" ]; then
		echo init_ucom
		init_ucom
	else
		echo init_rcom
		init_rcom
	fi
}

productinfo()
{
        if [ -f "/etc/.productinfo" ];then
                #echo "R系"
                #kernel-core 系统内必安装，获取版本号，与系统内的进行对比
		new_kernel_name=`ls kernel_pkg/kernel-core-* | awk -F'/' '{print $2}'   | awk -F'-' '{print $3}' `'-'`ls kernel_pkg/kernel-core-* | awk -F'/' '{print $2}'   | awk -F'-' '{print $4}'  | awk -F'.rpm' '{print $1}'`
                kernel_version_after_update=`rpm -qa kernel-core  |grep $new_kernel_name  `
                if [ -n "$kernel_version_after_update" ]; then
			echo "update_success"
		else
			echo "update_fail"
		fi

        else
                #echo "U系"
                new_kernel_name=`ls kernel_pkg/kylin-image-* | awk -F'/' '{print $2}' | awk -F'_' '{print $1}'`
                kernel_version_after_update=`dpkg -s $new_kernel_name | grep "Version:" | awk -F':' '{print $2}' | tr -d ' '`
                if [ -n "$kernel_version_after_update" ]; then
                        echo "update_success"
                else
                        echo "update_fail"
                fi
	fi
}

cd kernel/

case $1 in
UP)
	check_deb_or_rpm
	collect_kernel_info
	init_com $PKG_DEB_OR_RPM
	backup_kernel $PKG_DEB_OR_RPM
	update_kernel $PKG_DEB_OR_RPM
	productinfo
	;;
RB)
	check_deb_or_rpm
	get_kernel_info
	init_com $PKG_DEB_OR_RPM
	rollback_kernel $PKG_DEB_OR_RPM
	;;
CK)
	check_new_and_old_kernel_version
	;;
*)
	ret=0
	;;
esac

##return $ret
