#!/bin/bash
# SPDX-License-Identifier: GPL-2.0

###必须项
source trace_kprobe_core.sh
source other_util.sh
TASK=A
###

###可选项，用于ctrl c退出kprobe
function int_handler() {
    kprobe_exit
	echo "kprobe exit"
	get_snmp end_${TASK}_snmp.log
    get_netstat end_${TASK}_netstat.log
    get_dmesg dmesg_${TASK}.log
    get_ifconfig end_${TASK}_ifconfig.log
	exit
}

trap 'int_handler' INT
###

###定制任务A
function startA() {
	clean_kprobe_events
	clean_trace

    #KPRBE
	add_kprobe_event 'r:probeA1 raw_rcv $retval'
	#set_kprobe_event_filter 'arg1 != 0' probeA1

	add_kprobe_event 'r:probeA2 raw_rcv_skb $retval'
	#set_kprobe_event_filter 'arg1 != 0' probeA2

	add_kprobe_event 'r:probeA3 sock_queue_rcv_skb $retval'
	set_kprobe_event_filter 'arg1 != 0' probeA3

    #add_kprobe_event 'r:probeA31 sk_filter_trim_cap $retval'
    #set_kprobe_event_filter 'arg1 != 0' probeA31


    enable_kprobe_IP 'probeA4'
    add_kprobe_event 'r:probeA5 ip_expire $retval'
    #add_kprobe_event 'r:probeA6 __netif_receive_skb_core $retval'
    #set_kprobe_event_filter 'arg1 != 0' probeA6
    add_kprobe_event 'r:probeA7 enqueue_to_backlog $retval'
    set_kprobe_event_filter 'arg1 != 0' probeA7

    add_kprobe_event 'r:probeA8 ping_rcv $retval'

    add_kprobe_event 'r:probeA9 __xfrm_policy_check $retval'
    add_kprobe_event 'r:probeA10 kfree_skb $retval'

    #TRACE
    enable_trace_event 'sock/sock_rcvqueue_full'

	enable_kprobe_events
    #disable_kprobe_IP
	get_snmp start_${TASK}_snmp.log
    get_netstat start_${TASK}_netstat.log
    get_ifconfig start_${TASK}_ifconfig.log
	echo "kprobe start"
	get_trace_pipe "${TASK}.log"
	echo "kprobe end"
}
###

###执行任务A
startA
###
