#!/bin/bash
# SPDX-License-Identifier: GPL-2.0

source trace_kprobe_core.sh
source other_util.sh

TASK=B

function int_handler() {
    kprobe_exit
    echo "kprobe exit"
    get_snmp end_${TASK}_snmp.log
    get_netstat end_${TASK}_netstat.log
    get_dmesg dmesg_${TASK}.log
    get_ifconfig end_${TASK}_ifconfig.log
    exit
}

trap 'int_handler' INT

function startB() {
	clean_kprobe_events
	clean_trace

	#add_kprobe_event 'r:probeB11 ping_v4_sendmsg $retval'
	#add_kprobe_event 'r:probeB12 raw_sendmsg $retval'
	add_kprobe_event 'r:probeB1 ip_append_data $retval'
	set_kprobe_event_filter 'arg1 != 0' probeB1

	add_kprobe_event 'r:probeB2 sock_alloc_send_skb $retval'
	set_kprobe_event_filter 'arg1 == 0' probeB2

    enable_kprobe_IP 'probeB3'
    add_kprobe_event 'r:probeB4 ip_expire $retval'

	enable_kprobe_events
	get_snmp start_${TASK}_snmp.log
    get_netstat start_${TASK}_netstat.log
    get_ifconfig start_${TASK}_ifconfig.log
	echo "kprobe start"
	get_trace_pipe "${TASK}.log"
	echo "kprobe end"
}

startB
