#!/bin/bash
# SPDX-License-Identifier: GPL-2.0

###必须项
source trace_kprobe_core.sh
source other_util.sh
TASK=C
###

###可选项，用于ctrl c退出kprobe
function int_handler() {
    trace_exit
	echo "trace exit"
	get_snmp end_${TASK}_snmp.log
    get_netstat end_${TASK}_netstat.log
    get_dmesg dmesg_${TASK}.log
    get_ifconfig end_${TASK}_ifconfig.log
	exit
}

trap 'int_handler' INT
###

###定制任务
function start_task() {
	clean_kprobe_events
	clean_trace

    #TRACE
    enable_trace_event 'rcu'
    set_trace_event_filter 'common_pid == 1' 'rcu'

	get_snmp start_${TASK}_snmp.log
    get_netstat start_${TASK}_netstat.log
    get_ifconfig start_${TASK}_ifconfig.log
	echo "trace start"
	get_trace_pipe "${TASK}.log"
	echo "trace end"
}
###

###执行任务
start_task
###
