#!/bin/bash
# SPDX-License-Identifier: GPL-2.0

###必须项
source trace_kprobe_core.sh
source other_util.sh
TASK=E
###

###可选项，用于ctrl c退出kprobe
function int_handler() {
    kprobe_exit
	echo "kprobe exit"
	get_snmp end_${TASK}_snmp.log
    get_netstat end_${TASK}_netstat.log
    get_dmesg dmesg_${TASK}.log
    get_ifconfig end_${TASK}_ifconfig.log
	exit
}

trap 'int_handler' INT
###

###定制任务A
function startA() {
	clean_kprobe_events
	clean_trace

    #KPRBE

	add_kprobe_event 'r:probeE1 sock_alloc_send_pskb $retval'
	set_kprobe_event_filter 'arg1 == 0' probeE1
	add_kprobe_event 'r:probeE2 unix_dgram_peer_wake_me $retval'
	set_kprobe_event_filter 'arg1 == 1' probeE2
	add_kprobe_event 'r:probeE3 unix_dgram_sendmsg $retval'
	set_kprobe_event_filter 'arg1 == 0xfffffff5' probeE3

    enable_trace_event 'sock/sock_rcvqueue_full'
    enable_trace_event 'sock/sock_exceed_buf_limit'
	#add_kprobe_event 'r:probeE4 unix_diag_handler_dump $retval'
	#add_kprobe_event 'r:probeE5 unix_inq_len $retval'
	#set_kprobe_event_filter 'arg1 > 0' probeE5
	#add_kprobe_event 'r:probeE6 unix_outq_len $retval'
	#set_kprobe_event_filter 'arg1 > 0' probeE6

	enable_kprobe_events
    #disable_kprobe_IP
	get_snmp start_${TASK}_snmp.log
        get_netstat start_${TASK}_netstat.log
        get_ifconfig start_${TASK}_ifconfig.log
	echo "kprobe start"
	get_trace_pipe "${TASK}.log"
	echo "kprobe end"
}
###

###执行任务A
startA
###
