#!/bin/bash
# SPDX-License-Identifier: GPL-2.0

set -e

make
sudo dmesg -C
sudo insmod kylin_cpu_analysis.ko
cat /proc/kylin_cpu_analysis/log

# Run kylin_cpu_analysic_user_tool in the background and store its PID
./kylin_cpu_analysic_user_tool 10 &
USERAPP_PID=$!

# Check if kylin_cpu_analysic_user_tool is still running
if ! ps -p $USERAPP_PID > /dev/null; then
    echo "Error: kylin_cpu_analysic_user_tool failed to start"
    sudo rmmod kylin_cpu_analysis
    pkill kylin_cpu_analysic_user_tool
    sudo dmesg
    exit 1
fi

echo "Reading the CPU log file"
cat /proc/kylin_cpu_analysis/log

echo "Sleeping 5 seconds"
sleep 6

if ! ps -p $USERAPP_PID > /dev/null; then
    echo "Error: kylin_cpu_analysic_user_tool terminated prematurely"
    exit 1
fi

echo "Reading the CPU log file"
cat /proc/kylin_cpu_analysis/log

echo "Sleeping 5 seconds"
sleep 6

if ! ps -p $USERAPP_PID > /dev/null; then
    echo "Error: kylin_cpu_analysic_user_tool terminated prematurely"
    exit 1
fi

echo "Reading the CPU log file"
cat /proc/kylin_cpu_analysis/log

sudo rmmod kylin_cpu_analysis
pkill kylin_cpu_analysic_user_tool
sudo dmesg
